<script lang="ts">
  import { onMount, onDestroy } from "svelte";
  const base_colours = [`#ff0000`, `#ff5a00`, `#ff9a00`, `#ffce00`, `#ffe808`];
  const randomChoice = () =>
    base_colours[Math.floor(Math.random() * base_colours.length)];

  let colors = new Array(15).fill("").map(() => randomChoice());

  let animateInterval: NodeJS.Timer | null = null;
  $: animate = !!animateInterval;
  const startAnimation = () => {
    if (animate) return;
    animateInterval = setInterval(() => {
      colors = colors.map((current) =>
        Math.random() < 0.8 ? current : randomChoice()
      );
    }, 100);
  };
  const stopAnimation = () => {
    if (!animateInterval) return;
    clearInterval(animateInterval);
    animateInterval = null;
  };

  onMount(() => {
    setTimeout(() => {
      startAnimation();
      setTimeout(stopAnimation, 2500);
    }, 3000);
  });
</script>

<!-- svelte-ignore a11y-mouse-events-have-key-events -->
<svg
  on:mouseover={startAnimation}
  on:mouseleave={stopAnimation}
  viewBox="0 0 1000 150"
  xmlns="http://www.w3.org/2000/svg"
>
  <defs />
  <path
    style={animate ? `fill: ${colors[0]};` : ``}
    d="M 25 100 L 50 150 L 0 150 L 25 100 Z"
  />
  <path
    style={animate ? `fill: ${colors[1]};` : ``}
    d="M 50 150 L 75 100 L 25 100 L 50 150 Z"
  />
  <path
    style={animate ? `fill: ${colors[2]};` : ``}
    d="M 50 50 L 75 100 L 25 100 L 50 50 Z"
  />
  <path
    style={animate ? `fill: ${colors[3]};` : ``}
    d="M 75 100 L 100 50 L 50 50 L 75 100 Z"
  />
  <path
    style={animate ? `fill: ${colors[4]};` : ``}
    d="M 75 0 L 100 50 L 50 50 L 75 0 Z"
  />
  <path
    style={animate ? `fill: ${colors[5]};` : ``}
    d="M 100 100 L 125 50 L 75 50 L 100 100 Z"
    transform="matrix(-1, 0, 0, -1, 200, 150)"
  />
  <path
    style={animate ? `fill: ${colors[6]};` : ``}
    d="M 100 100 L 125 150 L 75 150 L 100 100 Z"
    transform="matrix(-1, 0, 0, -1, 200, 250)"
  />
  <path
    style={animate ? `fill: ${colors[7]};` : ``}
    d="M 125 100 L 150 150 L 100 150 L 125 100 Z"
  />
  <path
    style={animate ? `fill: ${colors[8]};` : ``}
    d="M 150 150 L 175 100 L 125 100 L 150 150 Z"
  />
  <path
    style={animate ? `fill: ${colors[9]};` : ``}
    d="M 150 50 L 175 100 L 125 100 L 150 50 Z"
  />
  <path
    style={animate ? `fill: ${colors[10]};` : ``}
    d="M 175 50 L 200 100 L 150 100 L 175 50 Z"
    transform="matrix(-1, 0, 0, -1, 350, 150)"
  />
  <path
    style={animate ? `fill: ${colors[11]};` : ``}
    d="M 175 50 L 200 0 L 150 0 L 175 50 Z"
    transform="matrix(-1, 0, 0, -1, 350, 50)"
  />
  <path
    style={animate ? `fill: ${colors[12]};` : ``}
    d="M 200 100 L 225 50 L 175 50 L 200 100 Z"
    transform="matrix(-1, 0, 0, -1, 400, 150)"
  />
  <path
    style={animate ? `fill: ${colors[13]};` : ``}
    d="M 200 100 L 225 150 L 175 150 L 200 100 Z"
    transform="matrix(-1, 0, 0, -1, 400, 250)"
  />
  <path
    style={animate ? `fill: ${colors[14]};` : ``}
    d="M 225 150 L 250 100 L 200 100 L 225 150 Z"
    transform="matrix(-1, 0, 0, -1, 450, 250)"
  />
  <text x="250" y="125">
    <tspan style={animate ? `fill: ${colors[0]};` : ``}>o</tspan>
    <tspan style={animate ? `fill: ${colors[1]};` : ``}>r</tspan>
    <tspan style={animate ? `fill: ${colors[2]};` : ``}>g</tspan>
    <tspan style={animate ? `fill: ${colors[3]};` : ``}>a</tspan>
    <tspan style={animate ? `fill: ${colors[4]};` : ``}>n</tspan>
    <tspan xml:space="preserve" />
    <tspan style={animate ? `fill: ${colors[5]};` : ``}>T</tspan>
    <tspan style={animate ? `fill: ${colors[6]};` : ``}>r</tspan>
    <tspan style={animate ? `fill: ${colors[7]};` : ``}>e</tspan>
    <tspan style={animate ? `fill: ${colors[8]};` : ``}>n</tspan>
    <tspan style={animate ? `fill: ${colors[9]};` : ``}>c</tspan>
    <tspan style={animate ? `fill: ${colors[10]};` : ``}>h</tspan>
  </text>
</svg>

<style lang="scss">
  @import url(https://cdn.jsdelivr.net/npm/firacode@6.2.0/distr/fira_code.css);
  svg {
    fill: #ff9a00;

    * {
      transition: fill 1s;
    }

    path {
      pointer-events: all;
      stroke: none;
    }

    text * {
      font: 100px Fira Code Bold;
    }
  }
</style>
